import math; M=math
from idorudraw import beginLinesEntity
from idorudraw import line, line_from, line_to

def none(x, y, z=0):
    return 0

def plot(fnc = none):
    j = -20.0
    line_from(j, fnc(j))
    for i in range(-599, 600):
        k = i/30.0
        line_to(k, fnc(k))

# Archimedes sM.piral
### Segmented on 60deg M.pieces for better regionality
### Those segments are small and badly proportioned
### [FIXME]
def arch(x=0, y=0, a=0.01, n=10, l = 1): 
    d = 0.0
    for i in range(n*6):
        line_from(x+(M.cos(d*M.pi/180))*a*d,
                  y+(M.sin(d*M.pi/180))*a*d)
        for j in range(12):
            d = d+5.0
            line_to(x+(M.cos(d*M.pi/180))*a*d,
                    y+(M.sin(d*M.pi/180))*a*d)

def arch_old(x=0, y=0, a=0.01, n=10, l = 1): 
    line_from(x, y, l = l)
    d = 0.0
    line_to(x+(M.cos(d*M.pi/180))*a*d,
            y+(M.sin(d*M.pi/180))*a*d)
    for i in range(72*n):
        d = d+5.0
        line_to(x+(M.cos(d*M.pi/180))*a*d,
                y+(M.sin(d*M.pi/180))*a*d)
       
def arch_l(x=0, y=0, a=0.01, n=10, l=1): 
    beginLinesEntity(l)
    d = 0.0
    nx = x+(M.cos(d*M.pi/180))*a*d
    ny = y+(M.sin(d*M.pi/180))*a*d
    line(x, y, nx, ny)
    for i in range(72*n):
        d = d+5.0
        oldx = nx
        oldy = ny
        nx = x+(M.cos(d*M.pi/180))*a*d
        ny = y+(M.sin(d*M.pi/180))*a*d
        line(oldx, oldy, nx, ny)

# Fermat sM.piral
def ferm(x=0, y=0, a=1, n=10, l=1): 
    d = 0.0
    line_from(x, y, l=l)
    for i in range(72*n):
        line_to(x+(M.cos(d*M.pi/180))*a*sqrt(d),
                y+(M.sin(d*M.pi/180))*a*sqrt(d))
        d = d+5.0
    d = 0.0
    line_from(x, y, l=l)
    for i in range(72*n):
        line_to(x+(M.cos(d*M.pi/180))*a*-sqrt(d),
                y+(M.sin(d*M.pi/180))*a*-sqrt(d))
        d = d+5.0

# Inverse
def ferm2(x=0, y=0, a=100, n=10): 
    d = 1.0
    line_from(x+(M.cos(d*M.pi/180))*a/sqrt(d),
              y+(M.sin(d*M.pi/180))*a/sqrt(d))
    for i in range(72*n):
        d = d+5.0
        line_to(x+(M.cos(d*M.pi/180))*a/sqrt(d),
                y+(M.sin(d*M.pi/180))*a/sqrt(d))
    d = 1.0
    line_from(x+(M.cos(d*M.pi/180))*a/-sqrt(d),
              y+(M.sin(d*M.pi/180))*a/-sqrt(d))
    for i in range(72*n):
        d = d+5.0
        line_to(x+(M.cos(d*M.pi/180))*a/-sqrt(d),
                y+(M.sin(d*M.pi/180))*a/-sqrt(d))

        
# Bernoulli's lemniscate
def bern(x = 0, y = 0, a = 50):
    d = 0.0
    r = a * sqrt(M.cos(2*d*M.pi/180))
    line_from(x+(M.cos(d*M.pi/180))*r, y+(M.sin(d*M.pi/180))*r)
    for i in range(360):
        d = d + 1.0
        if M.cos(2*d*M.pi/180) >= 0:
            r = a * sqrt(M.cos(2*d*M.pi/180))
            line_to(x+(M.cos(d*M.pi/180))*r, y+(M.sin(d*M.pi/180))*r)


def cardioide(x = 0, y = 0, a = 15.0):
    d = 0.0
    r = 2.0 * a * (1.0 + M.cos(d*M.pi/180))
    line_from(x+(M.cos(d*M.pi/180))*r, y+(M.sin(d*M.pi/180))*r)
    for i in range(360):
        d = d + 1.0
        r = 2.0 * a * (1.0 + M.cos(d*M.pi/180))
        line_to(x+(M.cos(d*M.pi/180))*r, y+(M.sin(d*M.pi/180))*r)

# p/q and number of turns:

# 1/7 = 7/2; 1/6 = 6;   1/5 = 5/2; 1/4 = 4;   1/3 = 3/2; 1/2 = 2;   1/1 = 1/2;
# 2/7 = 7;   2/6 = 3/2; 2/5 = 5;   2/4 = 2;   2/3 = 3;   2/2 = 1/2; 2/1 = 1;
# 3/7 = 7/2; 3/6 = 2;   3/5 = 5/2; 3/4 = 4;   3/3 = 1/2; 3/2 = 2;   3/1 = 1/2;
# 4/7 = 7;   4/6 = 3;   4/5 = 5;   4/4 = 1/2; 4/3 = 3;   4/2 = 1;   4/1 = 1;
# 5/7 = 7/2; 5/6 = 6;   5/5 = 1/2; 5/4 = 4;   5/3 = 3/2; 5/2 = 2;   5/1 = 1/2;

# 1, 1, 2, 3, 5, 8, 13, 21, 34, 55, 89, 144, 233
# 13/21 = 11; 21/34 = 34;
# 21/13 =  7; 34/21 = 21;

# Will not find out if p/q can be simplified
def rosa_turns(p, q):
    #    if p == q:
    #        return 0.5
    if p%2 and q%2:
        return float(q)/2
    else:
        return q

# r = a * M.cos((p/q)angle)
def rosa(p=3, q=1, times = 1, x=0, y=0, z = 0, a=10,
         vol = 1, quality = 6.0):
    d = 0.0
    r = a * M.cos((float(p)/float(q))*(d*M.pi/180.0))
    line_from(x + M.cos(d*M.pi/180)*r,
              y + M.sin(d*M.pi/180)*r,
              z)
    for i in range((360/quality)*rosa_turns(p, q)*times):
        d = d + quality
        r = a * M.cos((float(p)/float(q))*(d*M.pi/180.0))
        line_to(x + M.cos(d*M.pi/180)*r,
                y + M.sin(d*M.pi/180)*r,
                z + vol * (float(i)/(360/quality)))
                #z + M.sin(float(i)*M.pi/(rosa_turns(p, q)*times*360)))
r = rosa

def rosa2(p=3, q=1, times = 1, x=0, y=0, z = 0, a=10, quality = 6.0):
    d = 0.0
    r = a * (1.0-M.cos((float(p)/float(q))*(d*M.pi/180.0)))
    line_from(x + M.cos(d*M.pi/180)*r,
              y + M.sin(d*M.pi/180)*r,
              z)
    for i in range((360/quality)*times):
        d = d + quality
        r = a * (1.0-M.cos((float(p)/float(q))*(d*M.pi/180.0)))
        line_to(x + M.cos(d*M.pi/180)*r,
                y + M.sin(d*M.pi/180)*r,
                z + float(i)/(360/quality))

def astroide(r = 10, x =0, y = 0):
    d = 0
    line_from(r * M.cos(d*M.pi/180)**3,
              r * M.sin(d*M.pi/180)**3)
    for i in range(1, 361):
        d = d + 1.0
        line_to(r * M.cos(d*M.pi/180)**3,
                r * M.sin(d*M.pi/180)**3)

# Gerono lemniscate: {M.Cos[t], M.Cos[t] M.Sin[t]}, Period: 2 M.Pi
def gerono(x = 0, y = 0, a = 10):
    d = 0
    line_from(a * M.cos(d*M.pi/180),
              a * M.cos(d*M.pi/180) * M.sin(d*M.pi/180))
    for i in range(1, 361):
        d = d + 1.0
        line_to(a * M.cos(d*M.pi/180),
                a * M.cos(d*M.pi/180) * M.sin(d*M.pi/180))
# catenaria: {t, M.Cosh[t]}
# cissoid: {M.Sin[t]^2, M.Sin[t]^2*Tan[t]}, -M.Pi/2 < t < M.Pi/2
#       or {1,t}*(t^2/(1+t^2)), -Infinity < t < Infinity
# Limacon of Pascal: R == (k + 2 r M.Cos[t])

# http://www.jimloy.com/fractals/wave.htm
def wave(d = 9, z = 0):
    line_from(-20, 0, z)
    for i in range(-400, 401):
        x = float(i)/20
        y = M.sin(x)
        for j in range(1, d+1):
            y = y + M.sin(2.0**j * x)/(2.0**j)
        line_to(x, y, z)

