from idorudraw import triangle_from, triangle_to
from idorudraw import beginTrianglesEntity, triangle
import math; M=math

def avg(x, y):
    return (x+y)/2.0

def cell(x0, y0, x1, y1, x2, y2, x3, y3,
         z0=0, z1=0, z2=0, z3=0):
    # Normal; the third column is used for side lengths
    dx1 = x1-x0; dx2 = x2-x0; dx3 = x2-x1;
    dy1 = y1-y0; dy2 = y2-y0; dy3 = y2-y1;
    dz1 = z1-z0; dz2 = z2-z0; dz3 = z2-z1;
    nx = (dy1*dz2)-(dz1*dy2)
    ny = (dz1*dx2)-(dx1*dz2)
    nz = (dx1*dy2)-(dy1*dx2)
    # Center: not quite trivial
    cx = 0
    cy = 0
    cz = 0
    # Area
    len1 = M.sqrt(dx1**2 + dy1**2 + dz1**2)
    len2 = M.sqrt(dx2**2 + dy2**2 + dz2**2)
    len3 = M.sqrt(dx3**2 + dy3**2 + dz3**2)
    semiperimeter = (len1 + len2 + len3)/2.0
    s = semiperimeter
    surface = M.sqrt(s * (s-len1) * (s-len2) * (s-len3))
    
    # Middle points
    x01 = avg(x0, x1); y01 = avg(y0, y1); z01 = avg(z0, z1)
    x02 = avg(x0, x2); y02 = avg(y0, y2); z02 = avg(z0, z2)
    x03 = avg(x0, x3); y03 = avg(y0, y3); z03 = avg(z0, z3)
    x12 = avg(x1, x2); y12 = avg(y1, y2); z12 = avg(z1, z2)
    x23 = avg(x2, x3); y23 = avg(y2, y3); z23 = avg(z2, z3)
    x13 = avg(x1, x3); y13 = avg(y1, y3); z13 = avg(z1, z3)

    return [
            ]

def pyramid(x0, y0, x1, y1, x2, y2, x3, y3,
            z0=0, z1=0, z2=0, z3=0, n=4):
##    beginTrianglesEntity()
    s = cell(x0, y0, x1, y1, x2, y2, x3, y3,
             z0, z1, z2, z3)
    for i in range(1, n):
        r = s
        s = []
        for j in range(8.0**i):
            s.extend( cell(r[j*12 + 0], r[j*12 + 1],
                           r[j*12 + 2], r[j*12 + 3],
                           r[j*12 + 4], r[j*12 + 5],
                           r[j*12 + 6], r[j*12 + 7],
                           r[j*12 + 8], r[j*12 + 9],
                           r[j*12 + 10], r[j*12 + 11] ))
##    for i in range(8.0**n):
##         tetra(s[i*12 + 0], s[i*12 + 1], s[i*12 + 2], s[i*12 + 3],
##               s[i*12 + 4], s[i*12 + 5], s[i*12 + 6], s[i*12 + 7],
##               s[i*12 + 8], s[i*12 + 9], s[i*12 + 10], s[i*12 + 11])
