import math; M=math
from idorudraw import beginLinesEntity
from idorudraw import line, line_from, line_to

def rectangle(x, y, z=0.0, l=1):
    # very bad... better than explicit anyway
    r = [x, -y, -x, -y, -x, y, x, y]
    line_from(x, y, z, l);
    for i in range(4):
        line_to(r[2*i], r[2*i+1], z)

def circle(r = 1, x = 0, y = 0, z = 0, q = 18, l = 1):
    # 360 must be divisible by q (quality)
    line_from(x + r, y, z, l)
    for i in range(1, (360/q)+1):
        line_to( x + M.cos(float(i*q)*M.pi/180)*r,
                 y + M.sin(float(i*q)*M.pi/180)*r,
                 z )

def polygon(r = 1, x = 0, y = 0, z = 0, n = 3, a = 0, l = 1):
    q = 360.0/n
    line_from(x + M.cos(((0*q)+a)*M.pi/180)*r,
              y + M.sin(((0*q)+a)*M.pi/180)*r,
              z,
              l = l)
    for i in range(1, n+1):
        line_to( x + M.cos(((i*q)+a)*M.pi/180)*r,
                 y + M.sin(((i*q)+a)*M.pi/180)*r,
                 z )
p = polygon # Alias
##
# for i in range(20): p(n=3, a=i*6)
# for i in range(15): p(n=4, a=i*6) # etc...
##

def diamond(x, y, z=0, l = 1):
    beginLinesEntity(l)
    r = [x, 0, 0, y, -x, 0, 0, -y, x, 0]
    for i in range(4):
        line(r[2*i], r[2*i+1], r[2*i+2], r[2*i+3], z, z)
