import xml.dom.minidom

import idorudraw as D
import arc as bow
import shapes

def is_xml(fp):
    fp.seek(0)
    l  = fp.readline()
    if (l.find("<?xml") == 0):
        return True
    else:
        return False

def read(path):
    d = xml.dom.minidom.parse(path)
    processLayers(d.getElementsByTagName("image:Layers"))
    d.unlink()
    return

def processLayers(layers):
    for layer in layers:
        processLayer(layer)
    return

## Warning: getElementsByTagName catches *all* descendants
def processLayer(layer):
    pts = processPoints(layer.getElementsByTagName("image:Point"))
    print pts
    processLines(pts, layer.getElementsByTagName("image:Segment"))
    processCircles(pts, layer.getElementsByTagName("image:Circle"))    
    processArcs(pts, layer.getElementsByTagName("image:Arc"))
    return

def processPoints(points):
    ret = []
    for point in points:
        ## Let's assume the points come in order (probably a mistake)
        ret.extend([[float(point.getAttribute("x")),
                     float(point.getAttribute("y"))]])
    return ret

def processCircles(points, circles):
    for circle in circles:
        c = int(circle.getAttribute("cp"))
        ratio = float(circle.getAttribute("r"))
        shapes.circle(ratio, points[c][0], points[c][1])
    return

def processArcs(points, arcs):
    for arc in arcs:
        c = int(arc.getAttribute("cp"))
        ratio = float(arc.getAttribute("r"))
        a1 = float(arc.getAttribute("sa"))
        a2 = float(arc.getAttribute("ea"))
        bow.craa(points[c][0], points[c][1], ratio, a1, a2)
    return

def processLines(points, lines):
    D.beginLinesEntity()
    for line in lines:
        p1 = int(line.getAttribute("p1"))
        p2 = int(line.getAttribute("p2"))
        D.line(points[p1][0], points[p1][1], points[p2][0], points[p2][1])
    return
